
/*
 *	C M A P
 *  This table is used to quickly determine what characters are valid
 *  for printing.  Algorithm: if cmap[char] == 0 then don't print.
 *  Note that with minor mods to copyn() this table could be used to
 *  actually map characters (e.g. lower to upper case).
 */
char cmap[] = {
	0, 0, 0, 0, 0, 0, 0, 1,		/* null - bell */
	0, 1, 1, 0, 1, 1, 0, 0,		/* bs - si */
	0, 0, 0, 0, 0, 0, 0, 0,		/* dle - etb */
	0, 0, 0, 0, 0, 0, 0, 0,		/* can - us */
	1, 1, 1, 1, 1, 1, 1, 1,		/* sp - ' */
	1, 1, 1, 1, 1, 1, 1, 1,		/* ( - / */
	1, 1, 1, 1, 1, 1, 1, 1,		/* 0 - 7 */
	1, 1, 1, 1, 1, 1, 1, 1,		/* 8 - ? */
	1, 1, 1, 1, 1, 1, 1, 1,		/* @ - G */
	1, 1, 1, 1, 1, 1, 1, 1,		/* H - O */
	1, 1, 1, 1, 1, 1, 1, 1,		/* P - W */
	1, 1, 1, 1, 1, 1, 1, 1,		/* X - _ */
	1, 1, 1, 1, 1, 1, 1, 1,		/* ` - g */
	1, 1, 1, 1, 1, 1, 1, 1,		/* h - o */
	1, 1, 1, 1, 1, 1, 1, 1,		/* p - w */
	1, 1, 1, 1, 1, 1, 1, 0,		/* x - del */
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  1 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  2 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  3 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  4 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  5 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  6 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  7 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  8 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO  9 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO 10 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO 11 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO 12 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO 13 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO 14 ***/
	0, 0, 0, 0, 0, 0, 0, 0,		/*** Sign Bit On, NO-GO 15 ***/
	0, 0, 0, 0, 0, 0, 0, 0		/*** Sign Bit On, NO-GO 16 ***/
};

/*
 *		C O P Y N
 *  Copyn copies at most nlines number of lines from the given file.
 *  Output is always the standard output.  If binary is encountered,
 *  the binary is printed as "\nnn" where nnn is the octal representation
 *  of the character.  There is special handling for backspace.
 */
long
copyn (fp, nlines)
FILE	*fp;
long	nlines;
{
	char	inbuf[BUFSIZ];
	char	outbuf[LINESIZ+6];
	register char	*ip, *op;
	register char	c;
	int	val;

	while (fgets (inbuf, BUFSIZ, fp) != NULL) {
		inbuf[LINESIZ-1] = 0;
		if (nlines > 0L && linecount >= nlines) {
			linecount++;
			return;
		}
		ip = inbuf;
		op = outbuf;
		while (c = *ip++) {
			if( cmap[ c&0377 ] != 0 )
				*op++ = c;
			else if( c == BS ) {
				if( op > outbuf )
					op--;
			} else {
				*op++ = '\\';
				val = c & 0377;
				*op++ = ((val >> 6) & 07) + '0';
				*op++ = ((val >> 3) & 07) + '0';
				*op++ = (val & 07) + '0';
			}
			if( op > ( outbuf + LINESIZ ))
				break;
		}
		if( *(op-1) != '\n' )
			*op++ = '\n';
		*op = 0;
		fputs (outbuf, stdout);
		linecount++;
	}
	return;
}
