#include <stdio.h>
#ifdef BPRINT
#include "chset.h"
#endif
#ifdef BPRINT1
#define	bprint	bprint1
#define	chset	chset1
#include "chset1.h"
#endif
/*
 *$Log:	bprint.v $
 * Revision 1.4  83/05/07  11:11:59  dave
 * added defines in ifdefs so bprint & bprint1 can be selected from the
 * same library. The symbols are changed to make the 2 versions different.
 * 
 * Revision 1.3  83/04/11  14:18:40  herber
 * added inverse image option and changed calling sequence for bprint
 * 
 * Revision 1.2  83/04/07  16:22:13  herber
 * added -i (invert) option.
 * started on forground and background specification
 * 
 * Revision 1.1  83/04/06  15:53:36  herber
 * Initial revision
 * 
 */

/* bprint ---
 *	print a banner line to fp  with given linelength.
 *	returns 0 if succeeds, 1 if fails(linelength too short).
 */
int bprint( fp, s, fgchar, bgchar, invert, linewidth)
FILE	*fp;	/* banner output file pointer */
char	*s;
char	fgchar;	/* forground fill character */
char	bgchar;	/* background fill character */
int	invert;		/* flag for inverted characters */
int	linewidth;	/* number of characters in output line */
{
	static char rcsid[] = "$Header:   bprint.v  Revision 1.4  83/05/07  11:11:59  dave  Exp$";
	register char	*p;
	char	c;
	register int	col, h;
	register int	w, line, realh;
	register char	*background, *foreground;

	static char	blank =' ';

	if ( linewidth < CBEFORE+CWIDTH+CAFTER )
	{
		fprintf( stderr, "bprint: minimum line length is %d\n",
				CBEFORE+CWIDTH+CAFTER );
		return(1);		/* failure return */
	}

	if (invert)
	{
		foreground = bgchar ? &bgchar : &blank;
		background = fgchar ? &fgchar : &c;
	}
	else
	{
		background = bgchar ? &bgchar : &blank;
		foreground = fgchar ? &fgchar : &c;
	}

	do
	{
		for (w=0; w<CABOVE; w++)	/* skip rows above */
		{
			col = 0;
			for (p = s; c = *p; p++) /* for each character */
			{
				if (c == '\n')
				{
					p++;
					break;
				}
				if ((col += CBEFORE+CWIDTH+CAFTER) > linewidth)
					break;	/* won't fit on line */
				if (c < ' ')
					c = ' '; /* control characters are
							folded to spaces */

				for (w=0; w<CBEFORE+CWIDTH+CAFTER; w++)
					putc(*background, fp );
			}
			putc('\n', fp );
		}

		for (h=0; h<CHEIGHT+CDEPTH; h++) /* generate characters */
		{
			col = 0;
			for (p = s; c = *p; p++) /* for each character */
			{
				if (c == '\n')
				{
					p++;
					break;
				}
				if ((col += CWIDTH+CBEFORE+CAFTER) > linewidth)
					break;	/* won't fit on line */
				if (c < ' ')
					c = ' '; /* control characters are
							folded to spaces */

				switch (c)	/* adjust for decenders */
				{
					case 'g': case 'j':
					case 'p': case 'q':
					case 'y': case ',': case ';':
						realh = h - CDEPTH;
						break;

					default: realh = h;
				}

				if (realh<0 || realh >= CHEIGHT)
					line = 0;
				else
					line = chset[c-' '][realh];

				for (w = 0; w < CBEFORE; w++)
					putc(*background, fp );

				for (w = 1<<(CWIDTH-1); w; w>>=1)
					putc( w & line
						? *foreground
						: *background, fp );

				for (w = 0; w < CAFTER; w++)
					putc(*background, fp );
			}
			putc('\n', fp );
		}

		for (w=0; w<CBELOW; w++)	/* skip rows below */
		{
			col = 0;
			for (p = s; c = *p; p++) /* for each character */
			{
				if (c == '\n')
				{
					p++;
					break;
				}
				if ((col += CBEFORE+CWIDTH+CAFTER) > linewidth)
					break;	/* won't fit on line */
				if (c < ' ')
					c = ' '; /* control characters are
							folded to spaces */

				for (w=0; w<CBEFORE+CWIDTH+CAFTER; w++)
					putc(*background, fp );
			}
			putc('\n', fp );
		}
	} while (*(s = p));
	return (0);
}
